; GUI #
include win64a.inc
SEMAPHORE_DATA_COUNT = 16
;time_interval = 10
SemaphoreObjectStruct struct 
	hSemaphoreDataHigh	dq SEMAPHORE_DATA_COUNT dup(?)
	hSemaphoreDataLow	dq SEMAPHORE_DATA_COUNT dup(?)
	hSemaphoreAck	dq ?
SemaphoreObjectStruct ends

IDC_DIALOG	equ 200
ID_TXT		equ 100
ID_ICON		equ 102
ID_PROGRESS	equ 106
IDC_ICON1	equ 500
.code
WinMain proc
	enter	30h,0
	mov	r9d,offset DialogProc
	and	qword ptr[rbp-10h],0
        invoke  DialogBoxParam,IMAGE_BASE,IDC_DIALOG,HWND_DESKTOP
        invoke  RtlExitUserProcess,NULL
WinMain endp
DialogProc proc hWnddlg:qword,msg:qword,wParam:qword,lParam:qword

	mov	hWnddlg,rcx
	mov	lParam,r9

        cmp 	edx,WM_INITDIALOG
	jne 	wmBYE
wmINITDIALOG:mov hWnd,rcx
        mov 	edx,GWL_STYLE
	invoke	GetWindowLongPtr
    	or	eax,WS_THICKFRAME OR WS_MINIMIZEBOX OR WS_MAXIMIZEBOX
	mov	edx,GWL_STYLE
	invoke	SetWindowLongPtr,hWnddlg,,rax
	mov	r8d,offset WndProc
	mov	edx,GWL_WNDPROC
	invoke	SetWindowLongPtr,hWnddlg
;   
	mov	edx,offset szWin
        invoke  FindWindow,NULL
        or      eax,eax
        jnz	@f;wmBYE
	mov	edx,offset Error1
	mov	r8d,offset szAppName
	invoke	MessageBox,hWnddlg,,,MB_ICONEXCLAMATION or MB_YESNO
	cmp	eax,IDNO
	jz      @f;wmBYE      
	mov	ecx,offset szService
	invoke	WinExec,,SW_SHOW
; create "high" data event handles
	xor	edi,edi;for(DWORD i = 0; i < ; i++)
; set current event name
@@:	invoke	sprintf,&szSemaphoreName,&Format1,edi
; open existing object
	invoke	OpenSemaphore,SEMAPHORE_ALL_ACCESS,0,&szSemaphoreName
	mov	SemaphoreObject.hSemaphoreDataHigh[rdi*8],rax
	or	eax,eax
	jz	wmBYE
	invoke	sprintf,&szSemaphoreName,&Format2,edi
; open existing object
	invoke	OpenSemaphore,SEMAPHORE_ALL_ACCESS,0,&szSemaphoreName
	mov	SemaphoreObject.hSemaphoreDataLow[rdi*8],rax
; check for errors
	or	eax,eax;if(SemaphoreObject.hSemaphoreDataLow[i] == NULL)
	jz	wmBYE
	inc	edi
	cmp	edi,SEMAPHORE_DATA_COUNT
	jb	@b
; create acknowledgement event
	invoke	OpenSemaphore,SEMAPHORE_ALL_ACCESS,0,&Format3
	mov	SemaphoreObject.hSemaphoreAck,rax
;--------------------------------------------------
;  
	pushaddr szFont	
	push	FIXED_PITCH+FF_DONTCARE
	push	PROOF_QUALITY
	push	CLIP_DEFAULT_PRECIS
	push	OUT_RASTER_PRECIS
	push	ANSI_CHARSET
	push	FALSE
	push	FALSE
	push	FALSE
	push	FW_BOLD
	sub	esp,20h
        invoke  CreateFont,32,12,0,0                
        mov     hFont,rax

        invoke  GetDlgItem,hWnddlg,ID_PROGRESS
        mov     hProgress,rax
;    
	mov	r8d,offset ProgressWindowProc
        invoke  SetWindowLongPtr,hProgress,GWL_WNDPROC
        ;    
        mov     OldProc,rax
wmBYE:	xor	eax,eax
	leave
	retn
DialogProc endp
WndProc proc	hWnd:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	text:dword
local	ps:PAINTSTRUCT                
local	hDC:dword
local	rcClient:RECT

	mov	hWnd,rcx
	mov	lParam,r9

	cmp	edx,WM_CLOSE
	je	wmCLOSE
	cmp	edx,WM_COMMAND
	je	wmCOMMAND
	cmp	edx,WM_USER+1
	je	wmUSER_1
	cmp	edx,WM_USER+2
	je	wmUSER_2
	cmp	edx,WM_USER+3
	je	wmUSER_3
	leave
	jmp	NtdllDialogWndProc_
;-----------------------------------------------------
wmUSER_1:mov	rax,lParam		
	mov	DataLength,rax
	inc	eax
	invoke	GlobalAlloc,GPTR,eax
	mov	p_Text,rax
	invoke	SemaphoreRecieve,eax
	and	byte ptr[rdi],0
        invoke  SetDlgItemText,hWnd,ID_TXT,p_Text
	invoke	GlobalFree,p_Text
	jmp	wmBYE
wmUSER_2:and	percent,0
        xor	ecx,ecx
	mov	[rsp+20h],rcx
	movr	qword ptr[rsp+28h],hThread2
	mov	r8d,offset TimerFuncProgress
	invoke	CreateThread,,0,,13
	invoke	CloseHandle,hThread2
;------------------------------------------------------
	mov	rax,lParam		
	mov	DataLength,rax
	invoke	GlobalAlloc,GPTR,eax
	xor	ecx,ecx
	mov	[rsp+20h],rcx
	movr	qword ptr[rsp+28h],hThread3
	mov	r8d,offset TimerFuncICO
	invoke	CreateThread,,0,,eax
	invoke	CloseHandle,hThread3
	jmp	wmBYE
wmUSER_3:and	percent,0
        xor	ecx,ecx
	mov	[rsp+20h],rcx
	movr	qword ptr[rsp+28h],hThread4
	mov	r8d,offset TimerFuncProgress
	invoke	CreateThread,,0,,128
	invoke	CloseHandle,hThread4
;-----------------------------------------------
	mov	rax,lParam		
	mov	DataLength,rax
	invoke	GlobalAlloc,GPTR,eax
	xor	ecx,ecx
	mov	[rsp+20h],rcx
	movr	qword ptr[rsp+28h],hThread5
	mov	r8d,offset TimerFuncWAV
	invoke	CreateThread,,0,,eax
	invoke	CloseHandle,hThread5
	jmp	wmBYE
wmCOMMAND:cmp	r8d,BN_CLICKED shl 16 + IDCANCEL
	jne	wmBYE
wmCLOSE:invoke	EndDialog,,0	
;   -  
	xor	edi,edi
@@:	invoke	CloseHandle,SemaphoreObject.hSemaphoreDataHigh[rdi*8]
	inc	edi
	cmp	edi,2*SEMAPHORE_DATA_COUNT+1
	jb	@b
wmBYE:  mov	eax,TRUE
exit0:	leave
	ret 		
WndProc endp

TimerFuncICO proc p:qword
	mov	p,rcx

	invoke	SemaphoreRecieve
;  HICON   
	and	qword ptr[rsp+30h],LR_DEFAULTCOLOR;LR_DEFAULTCOLOR=0
	mov	qword ptr[rsp+20h],256
	mov	qword ptr[rsp+28h],256
	invoke  CreateIconFromResourceEx,p,DataLength,TRUE,30000h
	mov	[rsp+20h],rax
	invoke  SendDlgItemMessage,hWnd,ID_ICON,STM_SETIMAGE,IMAGE_ICON
	invoke	GlobalFree,p
exit2:	leave
	ret
TimerFuncICO endp

TimerFuncWAV proc p:qword
local	lpwiocb:WAVEHDR
local	hWaveOut:qword
	mov	p,rcx

	invoke	SemaphoreRecieve
WAVE:	mov	r8,p
;"RIFF"+(File size)+(File Type Header)+(Format chunk marker)+(Length of format data) = 14h
        add	r8d,14h
        lea	ecx,hWaveOut
        xor	r9,r9
	mov	[rsp+20h],r9
	mov	qword ptr[rsp+28h],WAVE_ALLOWSYNC
        or	edx,WAVE_MAPPER
        invoke	waveOutOpen
;    
	lea	edx,lpwiocb
	mov	edi,edx
	xor	eax,eax
	mov	ecx,(sizeof WAVEHDR)/8
	rep	stosq

	mov	rax,p
	mov	ecx,eax
;"RIFF"+(File size)+(File Type Header)+(Format chunk marker)+(Length of format data)+\
;(Type of format)+(Number of Channels)+(Sample Rate)+(Sample Rate*BitsPerSample*Channels/8)+\
;(BitsPerSample*Channels/8)+(Bits per sample)+(data chunk header)+(Size of the data section)=2Ch
	add	eax,2Ch

	mov	[rdx].WAVEHDR.lpData,rax ;  
	mov	eax,[rcx+4];  
	sub	eax,2Ch
	mov	[rdx].WAVEHDR.dwBufferLength,eax ;  

	invoke	waveOutPrepareHeader,hWaveOut,,sizeof WAVEHDR
;   
	lea	edx,lpwiocb
	mov	rcx,hWaveOut
	mov	r8d,sizeof WAVEHDR
	invoke	waveOutWrite
@@:	test	lpwiocb.dwFlags,WHDR_DONE
	jz	@b
	lea	edx,lpwiocb
	invoke	waveOutUnprepareHeader,hWaveOut,,sizeof WAVEHDR
	invoke	waveOutClose,hWaveOut
@1:	invoke	GlobalFree,p
exit2:	leave
	ret
TimerFuncWAV endp
TimerFuncProgress proc lParam:qword
	mov	lParam,rcx
;    
@@:	mov	r8d,percent
	mov	edx,offset szText
	mov	ecx,offset buff
        invoke  wsprintf
;    ProgressBar
	mov	r8d,offset buff
	mov	edx,offset szProp
        invoke  SetProp,hProgress
;     ProgressBar
	mov	r8d,percent
	mov	edx,offset szPerc
        invoke  SetProp,hProgress
;   
        invoke  InvalidateRect,hProgress,0,FALSE
        inc     percent
        cmp     percent,101
        je	exit0
	invoke	Sleep,lParam
	jmp	@b
exit0:	leave
	ret
TimerFuncProgress endp
SemaphoreRecieve proc p:qword
local	dwSemaphoreDataLowValue:byte

	mov	edi,ecx
	add	rcx,DataLength
	mov	EndDataLength,ecx
@@:	lea	edx,SemaphoreObject.hSemaphoreDataLow
	invoke	WaitForMultipleObjects,SEMAPHORE_DATA_COUNT,,0,2
	cmp	eax,SEMAPHORE_DATA_COUNT;if(dwSemaphoreDataLowValue >= SEMAPHORE_DATA_COUNT)
	jnb	exit1
; wait for "high" data value
	mov	dwSemaphoreDataLowValue,al
	lea	edx,SemaphoreObject.hSemaphoreDataHigh
	invoke	WaitForMultipleObjects,SEMAPHORE_DATA_COUNT,,0,0
; calculate byte value from high/low value
	shl	al,4;dwSemaphoreDataHighValue * 16
	add	al,dwSemaphoreDataLowValue
; store byte value
	stosb
; set acknowledgement event
	invoke	ReleaseSemaphore,SemaphoreObject.hSemaphoreAck,1,0
;------------------------------------------------------------------
; increase ptr
exit1:	cmp	edi,EndDataLength
	jb	@b;for(DWORD i = 0; i < EndDataLength; i++)
	leave
	ret
SemaphoreRecieve endp
ProgressWindowProc proc hEdit:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	text:dword
local	ps:PAINTSTRUCT                
local	hDC:dword
local	rcClient:RECT

	mov	hEdit,rcx
	mov	uMsg,rdx
	mov	wParam,r8
	mov	lParam,r9

	cmp	edx,WM_PAINT
	je	wmPAINT
	mov	[rsp+20h],r9;lParam
	mov	r9,wParam
	mov	r8,uMsg
	mov	rdx,hEdit
        invoke  CallWindowProc,OldProc
	jmp	wmBYE
wmPAINT:;  
        lea     edx,rcClient
        invoke  GetClientRect,hEdit;,edi
        ;    
	mov	edx,offset szProp
        invoke  GetProp,hEdit;hProgress
        mov     text,eax
;  
        lea     edx,ps
        invoke  BeginPaint,hEdit;hProgress
        mov     hDC,eax
; 
        invoke  SelectObject,hDC,hFont
        invoke  SetBkMode,hDC,TRANSPARENT
;   
        invoke  GetSysColorBrush,COLOR_WINDOW
        lea     edx,rcClient
        invoke  FillRect,hDC,,eax
;    ?
        cmp     text,0
        je      @f
        invoke  GetSysColor,COLOR_WINDOWTEXT
        invoke  SetTextColor,hDC,eax
	mov	edx,offset buff
	mov	qword ptr[rsp+20h],DT_NOPREFIX or DT_SINGLELINE or DT_VCENTER or DT_CENTER
        lea     r9d,rcClient
        invoke  DrawText,hDC,,-1                
@@:;     
	mov	edx,offset szPerc
        invoke  GetProp,hEdit;hProgress
        mov     ecx,eax
        lea     r9d,rcClient
        mov     eax,[r9].RECT.right
        sub     eax,[r9].RECT.left
        mul     ecx
        xor     edx,edx
        mov     ecx,100
        div     ecx
;   
        add     eax,[r9].RECT.left
;   
	mov	ecx,[r9].RECT.left
	mov	edx,[r9].RECT.top
	mov	r9d,[r9].RECT.bottom
        invoke  CreateRectRgn,,,eax
        invoke  SelectClipRgn,hDC,eax
        invoke  GetSysColorBrush,COLOR_HIGHLIGHT
	lea     edx,rcClient
        invoke  FillRect,hDC,,eax
;    ?
        cmp     text,0
        je      @f
        invoke  GetSysColor,COLOR_HIGHLIGHTTEXT
        invoke  SetTextColor,hDC,eax
	mov	qword ptr[rsp+20h],DT_NOPREFIX or DT_SINGLELINE or DT_VCENTER or DT_CENTER
	mov	edx,offset buff
        lea     r9d,rcClient
        invoke  DrawText,hDC,,-1
@@:	lea     edx,ps
        invoke  EndPaint,hDC
	xor	eax,eax
wmBYE:	leave
	retn
ProgressWindowProc endp
;-----------------------------------------------------------------------
.data
hWnd		dq ?
Format1		db "Song_of_the_South_H%u",0
Format2		db "Song_of_the_South_L%u",0
Format3		db "Song_of_the_South_A",0
p_Text		dq ?
p_ICO		dq ?
p_WAV		dq ?
szWin		db "Semaphore Sender",0
Error1		db "The server is not running.",10,"Run?",0
szAppName	db "Semaphore Reciever",0
szService	db "10s",0
hThread2	dq ?
hThread3	dq ?
hThread4	dq ?
hThread5	dq ?
szSemaphoreName	db 32 dup(?)
buff		db 100 dup(?)
szText  	db '%u%% completed',0
percent		dd 0
hProgress	dq ?
hFont		dq ?
szProp		db 'text',0
szPerc		db 'percent',0
szFont		db "Verdana",0
OldProc		dq ?
align 16
SemaphoreObject SemaphoreObjectStruct <>
DataLength	dq ?
EndDataLength	dd ?
end 