; GUI #
include win64a.inc
ID_TXT		equ 100
ID_SEND_TXT	equ 101
ID_SEND_ICO	equ 102
ID_SEND_WAV	equ 103
IDC_DIALOG	equ 200
IDC_ICON1	equ 500
IDC_IMG1 	equ 104
SEMAPHORE_DATA_COUNT = 16
size_of_buffer	 = 96
time_interval    = 10
SemaphoreObjectStruct struct 
	hSemaphoreDataHigh	dq SEMAPHORE_DATA_COUNT dup(?)
	hSemaphoreDataLow	dq SEMAPHORE_DATA_COUNT dup(?)
	hSemaphoreAck	dq ?
SemaphoreObjectStruct ends
.code
WinMain proc 
	enter	30h,0
	mov	r9d,256;cx
	mov	[rbp-10h],r9
	mov	qword ptr [rbp-8],LR_DEFAULTCOLOR
	invoke	LoadImage,IMAGE_BASE,IDC_ICON1,IMAGE_ICON;,256,256,LR_DEFAULTCOLOR
	mov	r9d,offset DialogProc
	mov	qword ptr[rbp-10h],rax;30h-10h=+20h
	invoke	DialogBoxParam,IMAGE_BASE,IDC_DIALOG,HWND_DESKTOP
	invoke	RtlExitUserProcess,NULL
WinMain endp

DialogProc proc hWnddlg:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	hFile:qword
local	szSemaphoreName[32]:byte
local	szReadWrite:qword	;number of bytes actually read or write
local	hResource:qword
local	pResource:qword

	mov	hWnddlg,rcx
	mov	lParam,r9

	cmp	edx,WM_INITDIALOG
	je	wmINITDIALOG
	cmp	edx,WM_CLOSE
	je	wmCLOSE
	cmp	edx,WM_COMMAND
	je	wmCOMMAND

	xor	eax,eax
	jmp	exit0
wmINITDIALOG:invoke GetDlgItem,,IDC_IMG1
	invoke	SendMessage,eax,STM_SETIMAGE,IMAGE_ICON,lParam
	xor	edi,edi;for(DWORD i = 0; i < 16; i++)
@@:; set current Semaphore name
	invoke	sprintf,&szSemaphoreName,&Format1,edi
; create new object
	invoke	CreateSemaphore,0,0,1,&szSemaphoreName
	mov	SemaphoreObject.hSemaphoreDataHigh[rdi*8],rax
; check for errors
	or	eax,eax;if(SemaphoreObject.hSemaphoreDataHigh[i] == NULL)
	jz	wmBYE;exit0;
; create "low" data Semaphore handles
; set current Semaphore name
	invoke	sprintf,&szSemaphoreName,&Format2,edi
; create new object
	invoke	CreateSemaphore,0,0,1,&szSemaphoreName
	mov	SemaphoreObject.hSemaphoreDataLow[rdi*8],rax
; check for errors
	or	eax,eax;if(SemaphoreObject.hSemaphoreDataLow[i] == NULL)
	jz	wmBYE;exit0
	inc	edi
	cmp	edi,SEMAPHORE_DATA_COUNT
	jb	@b
; create acknowledgement Semaphore
; create new object
	invoke	CreateSemaphore,0,0,1,&Format3
	mov	SemaphoreObject.hSemaphoreAck,rax
	jmp	wmBYE
wmSEND_TXT:invoke GlobalAlloc,GPTR,size_of_buffer
	mov	p,rax
	invoke  GetDlgItemText,hWnddlg,ID_TXT,eax,size_of_buffer
        or      eax,eax
        jz      wmBYE
	mov	dwLength,eax
	mov	edx,offset szWin
        invoke  FindWindow,NULL
        or      eax,eax
        jz      wmBYE
	mov	edx,WM_USER+1
	jmp	@0
;-----------------------------------------------------------
wmSEND_ICO:;    
        mov	edx,p1
	invoke	FindResource,0,,RT_ICON; find the resource
	mov	hResource,rax
	invoke  SizeofResource,0,eax		; get its size
	mov	dwLength,eax
	invoke	LoadResource,0,hResource	; load the resource
	invoke	LockResource,eax;pResource
	mov	p,rax
;-------------------------------------------------
	and	qword ptr[rsp+30h],LR_DEFAULTCOLOR;LR_DEFAULTCOLOR=0
	mov	qword ptr[rsp+20h],256
	mov	qword ptr[rsp+28h],256
	mov	edx,dwLength
	invoke  CreateIconFromResourceEx,eax,,TRUE,30000h;270376,TRUE,30000h
	mov	[rsp+20h],rax
	invoke  SendDlgItemMessage,hWnddlg,IDC_IMG1,STM_SETIMAGE,IMAGE_ICON
	xor	p1,11b
;   
	mov	edx,offset szWin
        invoke  FindWindow,NULL
        or      eax,eax
        jz      wmBYE
;   
	mov	edx,WM_USER+2
	jmp	@0
;-----------------------------------------------------------------------
wmSEND_WAV:mov	ecx,offset wav_file
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,\
        FILE_ATTRIBUTE_ARCHIVE,0
        mov	hFile,rax
        invoke	GetFileSize,eax,0
	mov	dwLength,eax
	invoke	GlobalAlloc,GPTR,eax
	invoke	GlobalLock,eax
	mov	p,rax
	lea	r9d,szReadWrite
	mov	r8d,dwLength
        invoke	ReadFile,hFile,eax,,,0
        invoke	CloseHandle,hFile
;-------------------------------------------------------
;   
	mov	edx,offset szWin
        invoke  FindWindow,NULL
        or      eax,eax
        jz      wmBYE
;   
	mov	edx,WM_USER+3
;------------------------------------------------
@0:;   
	mov	r9d,dwLength
	invoke	PostMessage,eax,,hWnddlg
	or	eax,eax
	jz	wmBYE;if(SemaphoreObject.hSemaphoreAck == NULL)
; ---------------------------------------------------------------------------
; send block data
	mov	rsi,p
	xor	edi,edi
@@:	movzx	eax,byte ptr[rdi+rsi]
;set "high" data Semaphore
	shr	al, 4
	invoke	ReleaseSemaphore,SemaphoreObject.hSemaphoreDataHigh[rax*8],1,0
	test	eax, eax
	jz	wmBYE
; set "low" data Semaphore
	movzx	eax,byte ptr[rdi+rsi]
	and	al,0Fh
	invoke	ReleaseSemaphore,SemaphoreObject.hSemaphoreDataLow[rax*8],1,0
	test	eax, eax
	jz	wmBYE
; wait for acknowledgement
	invoke	WaitForSingleObject,SemaphoreObject.hSemaphoreAck,INFINITE
	test	eax, eax
	jnz	wmBYE
	inc	edi 
	cmp	edi,dwLength
	jb	@b
	jmp	wmBYE
wmCOMMAND:cmp	r8d,BN_CLICKED shl 16 + ID_SEND_ICO
        je      wmSEND_ICO
	cmp	r8d,BN_CLICKED shl 16 + ID_SEND_TXT
        je      wmSEND_TXT
	cmp	r8d,BN_CLICKED shl 16 + ID_SEND_WAV
        je      wmSEND_WAV
	cmp     r8d,BN_CLICKED shl 16 + IDCANCEL
        jne     wmBYE
wmCLOSE:invoke	EndDialog,,0
;   -  
	xor	edi,edi
@@:	invoke	CloseHandle,SemaphoreObject.hSemaphoreDataHigh[rdi*8]
	inc	edi
	cmp	edi,2*SEMAPHORE_DATA_COUNT+1
	jb	@b
wmBYE:	mov	eax,TRUE
exit0:	leave
	retn
DialogProc endp
;------------------------------------------------------------
Format1		db "Song_of_the_South_H%u",0
Format2		db "Song_of_the_South_L%u",0
Format3		db "Song_of_the_South_A",0
p1		dd 1
wav_file	db '..\Images\03.wav',0
align 16
SemaphoreObject SemaphoreObjectStruct <>
szWin		db 'Semaphore Reciever',0
p		dq ?
dwLength	dd ?
end